org.springframework.orm.jdo.support

## Class StandardPersistenceManagerProxyBean

- java.lang.Object
- - org.springframework.orm.jdo.support.StandardPersistenceManagerProxyBean

- All Implemented Interfaces:
    FactoryBean<javax.jdo.PersistenceManager>

      public class StandardPersistenceManagerProxyBean
      extends Object
      implements FactoryBean<javax.jdo.PersistenceManager>

  Proxy that implements the `PersistenceManager` interface, delegating to a thread-bound PersistenceManager on each invocation - as defined by the JDO 2.1 specification. This class makes such a standard JDO PersistenceManager proxy available for bean references.

  The main advantage of this proxy is that it allows DAOs to work with a plain JDO PersistenceManager reference in JDO 2.1 style (see `PersistenceManagerFactory.getPersistenceManagerProxy()`), exposing the exact behavior that the target JDO provider implements.

  Note: This proxy requires JDO 2.1 or higher.

  Since:
    3.0
  Author:
    Juergen Hoeller
  See Also:
    `SpringPersistenceManagerProxyBean`, `PersistenceManagerFactory.getPersistenceManagerProxy()`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StandardPersistenceManagerProxyBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `javax.jdo.PersistenceManager` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends javax.jdo.PersistenceManager>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory pmf)` Set the target JDO PersistenceManagerFactory that this proxy should delegate to.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StandardPersistenceManagerProxyBean

          public StandardPersistenceManagerProxyBean()

  - ### Method Detail

    - #### setPersistenceManagerFactory

          public void setPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory pmf)

      Set the target JDO PersistenceManagerFactory that this proxy should delegate to. This should be the raw PersistenceManagerFactory, as accessed by JdoTransactionManager.
      See Also:
        `JdoTransactionManager`

    - #### getObject

          public javax.jdo.PersistenceManager getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<javax.jdo.PersistenceManager>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends javax.jdo.PersistenceManager> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<javax.jdo.PersistenceManager>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<javax.jdo.PersistenceManager>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`